;str datatype for YAS 2.0
;by Leif strand (leif.astrand@multi.fi)
;version: 1.0 (26.04.2003)

#define strrelptr(x) x-$-1 
strdata:
    .db 0                           ;lowest priority
    .db $0c                         ;detects strings 
    .db "str"                       ;3 byte descripiton

    .dw str_exec                    ;pointer to execute routine

    .dw str_enddetect-str_detect    ;lenght of detect routine
    .dw strrelptr(str_detect)       ;relative pointer to detect routine

    .dw str_endcomment-str_comment  ;lenght
    .dw strrelptr(str_comment)      ;pointer

    .dw str_endicon-str_icon        ;lenght
    .dw strrelptr(str_icon)         ;pointer


str_exec:
    call _clrLCD                    ;clear screen

;find string
    rst 10h                         ;find string
    ret c                           ;just in case...

;pointer to ahl
    call _DATA_SIZE_TO_DE           ;get lenght, load ahl
    call _load_ram_ahl              ;swap pages, make hl point to the beginning of the file

    ld b,c                          ;zero to bc, c is still 0 from _clrLCD
str_next_screen:
    ld (_penCol),bc                 ;go to top left corner of the screen

str_next_char:
    push hl                         ;save pointer
    ld a,(hl)                       ;get a char

;only display numbers and letters
    ld hl,str_char_bounds           ;here the bounds are saved
    ld b,(hl)                       ;get number of bounds
str_check_loop:
    inc hl                          ;next value
    cp (hl)                         ;check with this value
    jr c,str_bad_char               ;less than that, then it's a "bad" char
    inc hl                          ;next value
    cp (hl)                         ;compare
    jr c,str_disp_char              ;less than that, then it's a "good" char
    djnz str_check_loop
;continue here if none matched, that is if a > 'z'

str_bad_char:
    ld a,' '                        ;put a space instead of a bad char

;display the char
str_disp_char:
    push de                         ;save this
    call _vputmap                   ;display the number
    pop de                          ;get counter back
    pop hl                          ;pointer to string
    jr nz,str_next_row              ;go to next row if we've reached the end

;inc hl, check if the ram page should be changed
    inc hl                          ;next byte
    bit 6,h                         ;bit set if hl reached $c000
    jr z,str_dont_change_page       ;if not, then don't swap pages
;change page when needed
    ld h,$40                        ;make hl point to beginning of the page
    in a,(6)                        ;get page number
    inc a                           ;next page
    out (6),a                       ;swap
str_dont_change_page:

;count number of bytes
    dec de                          ;decrease counter
    ld a,e
    or d                            ;reached 0?
    jp z,_getkey                    ;then wait for a keypress and then exit
    jr str_next_char


;go to beginning of next row    
str_next_row:
    ld bc,_penCol
;go the beginning of row
    xor a
    ld (bc),a                       ;store 0 to _penCol
    inc bc                          ;now bc = _penRow
    
;go to next row
    ld a,(bc)                       ;get row
    add a,6                         ;add 6 to the value
    ld (bc),a                       ;save new value
    
;check for end of screen
    cp 60                           ;a = _penRow
    jr nz,str_next_char             ;display next char if not at the end of the row
    
;wait for keypress, then display next screen
    push hl
    push de                         ;save some data
    
    call _getkey                    ;get a keypress
    call _clrLCD                    ;doesn't affect a
    
    pop de
    pop hl                          ;restore the data
    
    cp kExit                        ;a is still keynumber from _getkey
    jr nz,str_next_screen           ;display next char if exit wasn't pressed
    ret                             ;quit the module


str_char_bounds:
    .db 3                           ;number of bounds
;a char within any of theese bounds is a valid char, and will be displayed, all other are invalid
    .db '0','9'+1
    .db 'A','Z'+1
    .db 'a','z'+1

;no comment / icon
str_icon:
str_comment:
    scf                             ;set carry
    ret
str_endcomment:
str_endicon:


;accept all strings
str_detect:
    or a                            ;reset carry
    ret
str_enddetect:

.end

